//
//@@̋Rm Version 1.15
//
//     2004/12/ 1 ˁ@P
//

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, ComCtrls,Clipbrd;

type

  TCell=array[0..7,0..7] of TImage;
  TcDat=array[0..7,0..7] of Integer;
  ToldP=array[0..64] of TPoint;
  TPanels=array[1..8]of TPanel;

  TForm1 = class(TForm)
    Panel: TPanel;
    MainMenu1: TMainMenu;
    Gmenu: TMenuItem;
    CMenu: TMenuItem;
    exitMenu: TMenuItem;
    KO1: TMenuItem;
    KS1: TMenuItem;
    size5: TMenuItem;
    size6: TMenuItem;
    size7: TMenuItem;
    size8: TMenuItem;
    KP1: TMenuItem;
    aboutMenu: TMenuItem;
    ImageList: TImageList;
    forB: TButton;
    backB: TButton;
    StatusBar1: TStatusBar;
    memKnight: TMemo;
    Edit1: TMenuItem;
    KC1: TMenuItem;
    N1: TMenuItem;

    procedure FormCreate(Sender: TObject);
    procedure CellMouseMove(Obj:TObject; sh:TShiftState; mx,my:Integer);
    procedure CellMouseDown(Obj:TObject; Bt:TMouseButton;
      sh:TShiftState; mx,my:Integer);
    procedure MenuClick(Sender: TObject);
    procedure sizeMenuClick(Sender: TObject);
    procedure forBClick(Sender: TObject);
    procedure backBClick(Sender: TObject);
    procedure KP1Click(Sender: TObject);
    procedure KC1Click(Sender: TObject);

  private
    Cell:TCell;
    cDat:TcDat;
    bSize,cSize,x,y,oldMx,oldMy,n,st:Integer;
    oldP:ToldP;
    pYoko,pTate:TPanels;

    procedure clearPanel;
    procedure drawCell;
    procedure putKnight(bx,by:Integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  i,j:Integer;
begin

  bSize:=5; // 傫ݒ
  cSize:=24;

  for i:=0 to 7 do // ֖ʍ쐬
    for j:=0 to 7 do
    begin

      Cell[j,i]:=TImage.Create(Panel);
      Cell[j,i].Parent:=Panel;

      Cell[j,i].OnMouseMove:=CellMouseMove; // Cxgnhݒ
      Cell[j,i].OnMouseDown:=CellMouseDown;

    end;

  // ՖʍW\pl쐬
  for i:=1 to 8 do
  begin

    pTate[i]:=TPanel.Create(Form1);
    pTate[i].Parent:=Form1;
    pTate[i].BorderStyle:=bsNone;
    pTate[i].BevelInner:=bvNone;
    pTate[i].BevelOuter:=bvNone;
    pTate[i].Ctl3D:=False;
    pTate[i].Caption:=intToStr(i);
    pTate[i].Width:=25;
    pTate[i].Height:=25;
    pTate[i].Left:=4;
    pTate[i].Top:=28+(i-1)*25;

    pYoko[i]:=TPanel.Create(Form1);
    pYoko[i].Parent:=Form1;
    pYoko[i].BorderStyle:=bsNone;
    pYoko[i].BevelInner:=bvNone;
    pYoko[i].BevelOuter:=bvNone;
    pYoko[i].Ctl3D:=False;
    pYoko[i].Caption:=intToStr(i);
    pYoko[i].Width:=25;
    pYoko[i].Height:=25;
    pYoko[i].Left:=32+(i-1)*25;
    pYoko[i].Top:=2;

  end;

  clearPanel;

end;

procedure TForm1.clearPanel; // Q[
var
  i,j:Integer;
begin

  Panel.Width:=bSize*(cSize+1)+1;
  Panel.Height:=bSize*(cSize+1)+1;

  for i:=0 to 7 do // ֖ʃC[Wx
    for j:=0 to 7 do
      Cell[j,i].Visible:=False;

  for i:=0 to bSize-1 do // eZ
    for j:=0 to bSize-1 do
    begin

      Cell[j,i].Width:=cSize;
      Cell[j,i].Height:=cSize;
      Cell[j,i].Left:=j*(cSize+1)+1;
      Cell[j,i].Top:=i*(cSize+1)+1;

      Cell[j,i].Visible:=True; // gpC[ŴݗL
      Cell[j,i].ShowHint:=False;

      cDat[j,i]:=3; // ׂẴ}Xړ\

    end;

  // ՖʍW\plݒ
  for i:=1 to 8 do
  begin

    if i>bSize then
    begin

      pTate[i].Visible:=False;
      pYoko[i].Visible:=False;

    end
    else
    begin

      pTate[i].Visible:=True;
      pYoko[i].Visible:=True;

    end;

  end;

  n:=0;

  for i:=0 to 64 do // ߋ̎胊XgNA
    oldP[i]:=Point(-1,-1);

  forB.Enabled:=False; // ߂Ei߂{^
  backB.Enabled:=False;

  st:=0;
  drawCell;

  memKnight.Text:='';

end;

procedure TForm1.drawCell; // ֖ʕ`
var
  i,j:Integer;
begin

  for i:=0 to bSize-1 do
    for j:=0 to bSize-1 do
      ImageList.Draw(Cell[j,i].Canvas,0,0,cDat[j,i]);

  Panel.Refresh;

  if st=0 then
    StatusBar1.SimpleText:='@'+intToStr(n+1)+''
  else if st=1 then
    StatusBar1.SimpleText:='@'+intToStr(n)+'Ŏl܂'
  else if st=2 then
    StatusBar1.SimpleText:='@'+intToStr(n)+'ŃNA'

end;

// Z̃}EXړ
procedure TForm1.CellMouseMove(Obj:TObject; sh:TShiftState; mx,my:Integer);
var
  i,j,xx,yy:Integer;
begin

  // OʂZĕ`悵ĐԘg
  ImageList.Draw(Cell[oldMx,oldMy].Canvas,0,0,cDat[oldMx,oldMy]);

  xx:=(TImage(Obj).Left-1) div (cSize+1);
  yy:=(TImage(Obj).Top-1) div (cSize+1);

  // ʂZgň͂
  if cDat[xx,yy]=3 then // zu\Ȃ
    TImage(Obj).Canvas.Pen.Color:=clBlue
  else                  // zusȂ
    TImage(Obj).Canvas.Pen.Color:=clRed;
  TImage(Obj).Canvas.PolyLine([Point(0,0),Point(cSize-1,0),
       Point(cSize-1,cSize-1),Point(0,cSize-1),Point(0,0)]);

  Panel.Refresh;

  // ̃Z̍WL^
  oldMx:=(TImage(Obj).Left-1) div (cSize+1);
  oldMy:=(TImage(Obj).Top-1) div (cSize+1);

end;

procedure TForm1.CellMouseDown(Obj:TObject; Bt:TMouseButton;
   sh:TShiftState; mx,my:Integer);
var
  wx,wy,i:Integer;
begin

  wx:=(TImage(Obj).Left-1) div (cSize+1); // NbNꂽ}X̍WvZ
  wy:=(TImage(Obj).Top-1) div (cSize+1);

  if not(cDat[wx,wy]=3) then // zusȂ߂
    Exit;

  x:=wx;
  y:=wy;
  st:=0;

  for i:=n to 64 do // ݂̎ȍ~̉ߋ̎胊XgNA
    oldP[i]:=Point(-1,-1);

  putKnight(x,y);

end;

procedure TForm1.putKnight(bx,by:Integer);
var
  i,j,wx,wy:Integer;
  ov:Boolean;
  str:String;
begin

  if n=1 then // ŏ̔zuʒuL
    cDat[oldP[0].x,oldP[0].y]:=4;

  for i:=0 to bSize-1 do // ȑO̔zu\NA
    for j:=0 to bSize-1 do
      if cDat[j,i]=3 then
        cDat[j,i]:=0;

  ov:=False;

  for i:=1 to 2 do // zu\쐬
  begin

    wx:=bx-i;
    wy:=3-abs(i);

    if (wx>=0) and (wx<bSize) then
    begin

      if ((by-wy)>=0) and ((by-wy)<bSize) then
        if cDat[wx,by-wy]=0 then
        begin

          cDat[wx,by-wy]:=3;
          ov:=True;

        end;

      if ((by+wy)>=0) and ((by+wy)<bSize) then
        if cDat[wx,by+wy]=0 then
        begin

          cDat[wx,by+wy]:=3;
          ov:=True;

        end;

    end;

    wx:=bx+i;
    wy:=3-abs(i);

    if (wx>=0) and (wx<bSize) then
    begin

      if ((by-wy)>=0) and ((by-wy)<bSize) then
        if cDat[wx,by-wy]=0 then
        begin

          cDat[wx,by-wy]:=3;
          ov:=True;
        end;

      if ((by+wy)>=0) and ((by+wy)<bSize) then
        if cDat[wx,by+wy]=0 then
        begin

          cDat[wx,by+wy]:=3;
          ov:=True;

        end;

    end;

  end;

  for i:=0 to bSize-1 do
    for j:=0 to bSize-1 do
      if cDat[j,i]=1 then
        cDat[j,i]:=2;

  x:=bx;
  y:=by;

  cDat[x,y]:=1; // ֖ʃf[^ɍ̔zuǉ

  oldP[n].x:=x; // ߋ̎胊Xgɍ̎ǉ
  oldP[n].y:=y;

  for i:=0 to n do
    if (i<9) then
      str:='  '+intToStr(i+1)+' '+'('+intToStr(oldP[i].x+1)+', '+
        intToStr(oldP[i].y+1)+')'#13#10+str
    else
      str:=' '+intToStr(i+1)+' '+'('+intToStr(oldP[i].x+1)+', '+
        intToStr(oldP[i].y+1)+')'#13#10+str;

  memKnight.Text:=str;

  for i:=n to 64 do // ݂̒ʉߎ萔\It
  if not(oldP[i].x=-1) then
    Cell[oldP[i].x,oldP[i].y].ShowHint:=False;

  n:=n+1; // 萔JE^XV

  Cell[x,y].Hint:=intToStr(n)+'ڂɒʉ'; // ʉߎ萔L^

  if KP1.Checked then
    Cell[x,y].ShowHint:=True;

  drawCell;

  if n>1 then
    backB.Enabled:=True
  else
    backB.Enabled:=False;

  if oldP[n].x=-1 then
    forB.Enabled:=False;

  if n=bSize*bSize then // I
  begin

    ShowMessage('NAłI');
    StatusBar1.SimpleText:='@'+'NA';
    st:=2;

  end else if not(ov) then
  begin

    ShowMessage('l܂łI');
    StatusBar1.SimpleText:='@'+intToStr(n)+'Ŏl܂';
    st:=1;

  end;
  
end;

procedure TForm1.MenuClick(Sender: TObject);
begin

  if Sender=CMenu then
  begin
    if Application.MessageBox('݂̃Q[jĐVQ[͂߂܂H',
      'mF', MB_OKCANCEL) =  IDOK then
      clearPanel;
  end;

  if Sender=exitMenu then
    Application.Terminate;

  if Sender=aboutMenu then
    ShowMessage('̋Rm Version 1.14 (C)1998-2003 ˁ@P');

end;

procedure TForm1.sizeMenuClick(Sender: TObject);
begin // ՖʃTCYj[

  TMenuItem(Sender).Checked:=True;

  if Sender=size5 then
  begin

    bSize:=5;
    clearPanel;

  end;

  if Sender=size6 then
  begin

    bSize:=6;
    clearPanel;

  end;

   if Sender=size7 then
  begin

    bSize:=7;
    clearPanel;

  end;

  if Sender=size8 then
  begin

    bSize:=8;
    clearPanel;

  end;

end;

procedure TForm1.KP1Click(Sender: TObject); // ʉߎ萔\j[
var
  i:Integer;
begin

  KP1.Checked:=not(KP1.Checked);

  for i:=0 to n-1 do // eZ̒ʉߎ萔\ݒ
    Cell[oldP[i].x,oldP[i].y].ShowHint:=KP1.Checked;

end;

procedure TForm1.forBClick(Sender: TObject);
begin // i߂{^

  putKnight(oldP[n].x,oldP[n].y);

  drawCell;


end;

procedure TForm1.backBClick(Sender: TObject);
begin // ߂{^

  cDat[oldP[n-1].x,oldP[n-1].y]:=0;

  n:=n-2;
  putKnight(oldP[n].x,oldP[n].y);

  st:=0;
  drawCell;

  forB.Enabled:=True;

end;

procedure TForm1.KC1Click(Sender: TObject);
begin

  Clipboard.SetTextBuf(PChar(memKnight.Text));

end;

end.
